using System;
using System.Data;
using System.Collections.Generic;
using System.Linq;

namespace DevTips.Tips
{
    class LinqGroupMinMax
    {
        public static void Print()
        {
            DataTable table = GetData();
            foreach (DataRow row in table.Rows)
            {
                System.Console.WriteLine($"\t{row["GroupID"]}\t{row["SalesPerson"]}\t{row["Sales"]}");
            }
        }

        public static void Client1()
        {
            var data = GetData().AsEnumerable();

            var result = from row in data
                         group row by row.Field<int>("GroupID") into g
                         select new
                         {
                             GroupID = g.Key,
                             SalesPerson = g.First(g2 => g2.Field<int>("Sales") == g.Min(g3 => g3.Field<int>("Sales"))).Field<string>("SalesPerson"),
                             Sales = g.Min(p => p.Field<int>("Sales"))
                         };

            foreach (var r in result)
            {
                System.Console.WriteLine($"{r.GroupID},{r.SalesPerson} , {r.Sales}");
            }
        }

        public static void Client2()
        {
            var data = GetData().AsEnumerable();

            var result = data.GroupBy(t => t.Field<int>("GroupID")).Select(g => new
            {
                GroupID = g.Key,
                SalesPerson = g.First(g2 => g2.Field<int>("Sales") == g.Min(g3 => g3.Field<int>("Sales"))).Field<string>("SalesPerson"),
                Sales = g.Min(p => p.Field<int>("Sales"))
            });
        }

        private static DataTable GetData()
        {
            DataTable table = new DataTable();
            table.Columns.Add("GroupID", typeof(int));
            table.Columns.Add("SalesPerson", typeof(string));
            table.Columns.Add("Sales", typeof(int));

            DataRow row = table.NewRow();
            row["GroupID"] = 1;
            row["SalesPerson"] = "Lee";
            row["Sales"] = 900;
            table.Rows.Add(row);

            row = table.NewRow();
            row["GroupID"] = 1;
            row["SalesPerson"] = "Li";
            row["Sales"] = 800;
            table.Rows.Add(row);

            row = table.NewRow();
            row["GroupID"] = 1;
            row["SalesPerson"] = "Park";
            row["Sales"] = 990;
            table.Rows.Add(row);

            row = table.NewRow();
            row["GroupID"] = 2;
            row["SalesPerson"] = "Tom";
            row["Sales"] = 500;
            table.Rows.Add(row);

            row = table.NewRow();
            row["GroupID"] = 2;
            row["SalesPerson"] = "Jane";
            row["Sales"] = 400;
            table.Rows.Add(row);

            row = table.NewRow();
            row["GroupID"] = 3;
            row["SalesPerson"] = "Irina";
            row["Sales"] = 600;
            table.Rows.Add(row);

            row = table.NewRow();
            row["GroupID"] = 3;
            row["SalesPerson"] = "Yong";
            row["Sales"] = 633;
            table.Rows.Add(row);

            return table;
        }
    }
}